diff --git a/lisp/epg.el b/lisp/epg.el
index f665453..0768697 100644
--- a/lisp/epg.el
+++ b/lisp/epg.el
@@ -197,6 +197,7 @@ cl-defstruct epg-context
   protocol
   program
   (home-directory epg-gpg-home-directory)
+  keyrings
   armor
   textmode
   include-certs
@@ -570,6 +571,11 @@ defun epg--start (context args)
 		       (if (epg-context-home-directory context)
 			   (list "--homedir"
 				 (epg-context-home-directory context)))
+		       (if (epg-context-keyrings context)
+			   (apply #'nconc
+				  (mapcar (lambda (elt)
+					    (list "--keyring" elt))
+					  (epg-context-keyrings context))))
 		       (unless (eq (epg-context-protocol context) 'CMS)
 			 '("--command-fd" "0"))
 		       (if (epg-context-armor context) '("--armor"))
@@ -1263,6 +1269,11 @@ defun epg--list-keys-1 (context name mode)
   (let ((args (append (if (epg-context-home-directory context)
 			  (list "--homedir"
 				(epg-context-home-directory context)))
+		       (if (epg-context-keyrings context)
+			   (apply #'nconc
+				  (mapcar (lambda (elt)
+					    (list "--keyring" elt))
+					  (epg-context-keyrings context))))
 		      '("--with-colons" "--no-greeting" "--batch"
 			"--with-fingerprint" "--with-fingerprint")
 		      (unless (eq (epg-context-protocol context) 'CMS)
